// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2

// Freeze types in this file:
// name="Freeze::Catalog", key="string", value="Freeze::CatalogData"

#ifndef __Catalog_h__
#define __Catalog_h__

#include <Freeze/Map.h>
#include <Freeze/CatalogData.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef FREEZE_API
#   ifdef FREEZE_API_EXPORTS
#       define FREEZE_API ICE_DECLSPEC_EXPORT
#   else
#       define FREEZE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace Freeze
{

class FREEZE_API CatalogKeyCodec
{
public:

    static void write(const ::std::string&, Freeze::Key& bytes, const ::Ice::CommunicatorPtr& communicator);
    static void read(::std::string&, const Freeze::Key& bytes, const ::Ice::CommunicatorPtr& communicator);
    static const std::string& typeId();
};

class FREEZE_API CatalogValueCodec
{
public:

    static void write(const ::Freeze::CatalogData&, Freeze::Value& bytes, const ::Ice::CommunicatorPtr& communicator);
    static void read(::Freeze::CatalogData&, const Freeze::Value& bytes, const ::Ice::CommunicatorPtr& communicator);
    static const std::string& typeId();
};

typedef Freeze::Map< ::std::string, ::Freeze::CatalogData, CatalogKeyCodec, CatalogValueCodec> Catalog;

}

#endif
