// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `EvictorStorage.ice'

#ifndef __Freeze_EvictorStorage_h__
#define __Freeze_EvictorStorage_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Identity.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef FREEZE_API
#   ifdef FREEZE_API_EXPORTS
#       define FREEZE_API ICE_DECLSPEC_EXPORT
#   else
#       define FREEZE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace Freeze
{

struct Statistics
{
    ::Ice::Long creationTime;

    ::Ice::Long lastSaveTime;

    ::Ice::Long avgSaveTime;

    FREEZE_API bool operator==(const Statistics&) const;
    FREEZE_API bool operator!=(const Statistics&) const;
    FREEZE_API bool operator<(const Statistics&) const;

    FREEZE_API void __write(::IceInternal::BasicStream*) const;
    FREEZE_API void __read(::IceInternal::BasicStream*);
};

struct ObjectRecord
{
    ::Ice::ObjectPtr servant;

    ::Freeze::Statistics stats;

    FREEZE_API bool operator==(const ObjectRecord&) const;
    FREEZE_API bool operator!=(const ObjectRecord&) const;
    FREEZE_API bool operator<(const ObjectRecord&) const;

    FREEZE_API void __write(::IceInternal::BasicStream*) const;
    FREEZE_API void __read(::IceInternal::BasicStream*);
};

}

#endif
