// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Router.ice'

#ifndef __Glacier2_Router_h__
#define __Glacier2_Router_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Router.h>
#include <Glacier2/Session.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef GLACIER2_API
#   ifdef GLACIER2_API_EXPORTS
#       define GLACIER2_API ICE_DECLSPEC_EXPORT
#   else
#       define GLACIER2_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Glacier2
{

class Router;
GLACIER2_API bool operator==(const Router&, const Router&);
GLACIER2_API bool operator!=(const Router&, const Router&);
GLACIER2_API bool operator<(const Router&, const Router&);

class Admin;
GLACIER2_API bool operator==(const Admin&, const Admin&);
GLACIER2_API bool operator!=(const Admin&, const Admin&);
GLACIER2_API bool operator<(const Admin&, const Admin&);

}

}

namespace Glacier2
{

class Router;
GLACIER2_API bool operator==(const Router&, const Router&);
GLACIER2_API bool operator!=(const Router&, const Router&);
GLACIER2_API bool operator<(const Router&, const Router&);

class Admin;
GLACIER2_API bool operator==(const Admin&, const Admin&);
GLACIER2_API bool operator!=(const Admin&, const Admin&);
GLACIER2_API bool operator<(const Admin&, const Admin&);

}

namespace IceInternal
{

GLACIER2_API void incRef(::Glacier2::Router*);
GLACIER2_API void decRef(::Glacier2::Router*);

GLACIER2_API void incRef(::IceProxy::Glacier2::Router*);
GLACIER2_API void decRef(::IceProxy::Glacier2::Router*);

GLACIER2_API void incRef(::Glacier2::Admin*);
GLACIER2_API void decRef(::Glacier2::Admin*);

GLACIER2_API void incRef(::IceProxy::Glacier2::Admin*);
GLACIER2_API void decRef(::IceProxy::Glacier2::Admin*);

}

namespace Glacier2
{

typedef ::IceInternal::Handle< ::Glacier2::Router> RouterPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::Router> RouterPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const RouterPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, RouterPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const RouterPtr&);
GLACIER2_API void __patch__RouterPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Glacier2::Admin> AdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::Admin> AdminPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const AdminPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, AdminPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const AdminPtr&);
GLACIER2_API void __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

namespace Glacier2
{

class GLACIER2_API PermissionDeniedException : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static PermissionDeniedException __PermissionDeniedException_init;

class GLACIER2_API SessionNotExistException : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static SessionNotExistException __SessionNotExistException_init;

}

namespace Glacier2
{

class GLACIER2_API AMD_Router_destroySession : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::Glacier2::AMD_Router_destroySession> AMD_Router_destroySessionPtr;

}

namespace IceAsync
{

namespace Glacier2
{

class GLACIER2_API AMD_Router_destroySession : public ::Glacier2::AMD_Router_destroySession, public ::IceInternal::IncomingAsync
{
public:

    AMD_Router_destroySession(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace Glacier2
{

class GLACIER2_API Router : virtual public ::IceProxy::Ice::Router
{
public:

    ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&);
    ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    void destroySession();
    void destroySession(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class GLACIER2_API Admin : virtual public ::IceProxy::Ice::Object
{
public:

    void shutdown();
    void shutdown(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace Glacier2
{

class GLACIER2_API Router : virtual public ::IceDelegate::Ice::Router
{
public:

    virtual ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void destroySession(const ::Ice::Context&) = 0;
};

class GLACIER2_API Admin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace Glacier2
{

class GLACIER2_API Router : virtual public ::IceDelegate::Glacier2::Router,
			    virtual public ::IceDelegateM::Ice::Router
{
public:

    virtual ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void destroySession(const ::Ice::Context&);
};

class GLACIER2_API Admin : virtual public ::IceDelegate::Glacier2::Admin,
			   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace Glacier2
{

class GLACIER2_API Router : virtual public ::IceDelegate::Glacier2::Router,
			    virtual public ::IceDelegateD::Ice::Router
{
public:

    virtual ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void destroySession(const ::Ice::Context&);
};

class GLACIER2_API Admin : virtual public ::IceDelegate::Glacier2::Admin,
			   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&);
};

}

}

namespace Glacier2
{

class GLACIER2_API Router : virtual public ::Ice::Router
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Glacier2::SessionPrx createSession(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___createSession(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void destroySession_async(const ::Glacier2::AMD_Router_destroySessionPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___destroySession(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__RouterPtr(void*, ::Ice::ObjectPtr&);

class GLACIER2_API Admin : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

#endif
