// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Session.ice'

#ifndef __Glacier2_Session_h__
#define __Glacier2_Session_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef GLACIER2_API
#   ifdef GLACIER2_API_EXPORTS
#       define GLACIER2_API ICE_DECLSPEC_EXPORT
#   else
#       define GLACIER2_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Glacier2
{

class Session;
GLACIER2_API bool operator==(const Session&, const Session&);
GLACIER2_API bool operator!=(const Session&, const Session&);
GLACIER2_API bool operator<(const Session&, const Session&);

class SessionManager;
GLACIER2_API bool operator==(const SessionManager&, const SessionManager&);
GLACIER2_API bool operator!=(const SessionManager&, const SessionManager&);
GLACIER2_API bool operator<(const SessionManager&, const SessionManager&);

}

}

namespace Glacier2
{

class Session;
GLACIER2_API bool operator==(const Session&, const Session&);
GLACIER2_API bool operator!=(const Session&, const Session&);
GLACIER2_API bool operator<(const Session&, const Session&);

class SessionManager;
GLACIER2_API bool operator==(const SessionManager&, const SessionManager&);
GLACIER2_API bool operator!=(const SessionManager&, const SessionManager&);
GLACIER2_API bool operator<(const SessionManager&, const SessionManager&);

}

namespace IceInternal
{

GLACIER2_API void incRef(::Glacier2::Session*);
GLACIER2_API void decRef(::Glacier2::Session*);

GLACIER2_API void incRef(::IceProxy::Glacier2::Session*);
GLACIER2_API void decRef(::IceProxy::Glacier2::Session*);

GLACIER2_API void incRef(::Glacier2::SessionManager*);
GLACIER2_API void decRef(::Glacier2::SessionManager*);

GLACIER2_API void incRef(::IceProxy::Glacier2::SessionManager*);
GLACIER2_API void decRef(::IceProxy::Glacier2::SessionManager*);

}

namespace Glacier2
{

typedef ::IceInternal::Handle< ::Glacier2::Session> SessionPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::Session> SessionPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const SessionPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, SessionPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const SessionPtr&);
GLACIER2_API void __patch__SessionPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Glacier2::SessionManager> SessionManagerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::SessionManager> SessionManagerPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const SessionManagerPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, SessionManagerPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const SessionManagerPtr&);
GLACIER2_API void __patch__SessionManagerPtr(void*, ::Ice::ObjectPtr&);

}

namespace Glacier2
{

class GLACIER2_API CannotCreateSessionException : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static CannotCreateSessionException __CannotCreateSessionException_init;

}

namespace IceProxy
{

namespace Glacier2
{

class GLACIER2_API Session : virtual public ::IceProxy::Ice::Object
{
public:

    void destroy();
    void destroy(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class GLACIER2_API SessionManager : virtual public ::IceProxy::Ice::Object
{
public:

    ::Glacier2::SessionPrx create(const ::std::string&);
    ::Glacier2::SessionPrx create(const ::std::string&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace Glacier2
{

class GLACIER2_API Session : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void destroy(const ::Ice::Context&) = 0;
};

class GLACIER2_API SessionManager : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Glacier2::SessionPrx create(const ::std::string&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace Glacier2
{

class GLACIER2_API Session : virtual public ::IceDelegate::Glacier2::Session,
			     virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void destroy(const ::Ice::Context&);
};

class GLACIER2_API SessionManager : virtual public ::IceDelegate::Glacier2::SessionManager,
				    virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Glacier2::SessionPrx create(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace Glacier2
{

class GLACIER2_API Session : virtual public ::IceDelegate::Glacier2::Session,
			     virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void destroy(const ::Ice::Context&);
};

class GLACIER2_API SessionManager : virtual public ::IceDelegate::Glacier2::SessionManager,
				    virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Glacier2::SessionPrx create(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace Glacier2
{

class GLACIER2_API Session : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void destroy(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___destroy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__SessionPtr(void*, ::Ice::ObjectPtr&);

class GLACIER2_API SessionManager : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Glacier2::SessionPrx create(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___create(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__SessionManagerPtr(void*, ::Ice::ObjectPtr&);

}

#endif
