// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Plugin.ice'

#ifndef __Ice_Plugin_h__
#define __Ice_Plugin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_API
#   ifdef ICE_API_EXPORTS
#       define ICE_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace Ice
{

class Plugin;
ICE_API bool operator==(const Plugin&, const Plugin&);
ICE_API bool operator!=(const Plugin&, const Plugin&);
ICE_API bool operator<(const Plugin&, const Plugin&);

class PluginManager;
ICE_API bool operator==(const PluginManager&, const PluginManager&);
ICE_API bool operator!=(const PluginManager&, const PluginManager&);
ICE_API bool operator<(const PluginManager&, const PluginManager&);

}

namespace IceInternal
{

ICE_API void incRef(::Ice::Plugin*);
ICE_API void decRef(::Ice::Plugin*);

ICE_API void incRef(::Ice::PluginManager*);
ICE_API void decRef(::Ice::PluginManager*);

}

namespace Ice
{

typedef ::IceInternal::Handle< ::Ice::Plugin> PluginPtr;

typedef ::IceInternal::Handle< ::Ice::PluginManager> PluginManagerPtr;

}

namespace Ice
{

}

namespace Ice
{

class ICE_API Plugin : virtual public ::Ice::LocalObject
{
public:

    virtual void destroy() = 0;
};

class ICE_API PluginManager : virtual public ::Ice::LocalObject
{
public:

    virtual ::Ice::PluginPtr getPlugin(const ::std::string&) = 0;

    virtual void addPlugin(const ::std::string&, const ::Ice::PluginPtr&) = 0;

    virtual void destroy() = 0;
};

}

#endif
