// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Admin.ice'

#ifndef __IcePack_Admin_h__
#define __IcePack_Admin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/SliceChecksumDict.h>
#include <IceBox/IceBox.h>
#include <IcePack/Exception.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_PACK_API
#   ifdef ICE_PACK_API_EXPORTS
#       define ICE_PACK_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_PACK_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IcePack
{

class ComponentDescriptor;
ICE_PACK_API bool operator==(const ComponentDescriptor&, const ComponentDescriptor&);
ICE_PACK_API bool operator!=(const ComponentDescriptor&, const ComponentDescriptor&);
ICE_PACK_API bool operator<(const ComponentDescriptor&, const ComponentDescriptor&);

class ServerDescriptor;
ICE_PACK_API bool operator==(const ServerDescriptor&, const ServerDescriptor&);
ICE_PACK_API bool operator!=(const ServerDescriptor&, const ServerDescriptor&);
ICE_PACK_API bool operator<(const ServerDescriptor&, const ServerDescriptor&);

class JavaServerDescriptor;
ICE_PACK_API bool operator==(const JavaServerDescriptor&, const JavaServerDescriptor&);
ICE_PACK_API bool operator!=(const JavaServerDescriptor&, const JavaServerDescriptor&);
ICE_PACK_API bool operator<(const JavaServerDescriptor&, const JavaServerDescriptor&);

class ServiceDescriptor;
ICE_PACK_API bool operator==(const ServiceDescriptor&, const ServiceDescriptor&);
ICE_PACK_API bool operator!=(const ServiceDescriptor&, const ServiceDescriptor&);
ICE_PACK_API bool operator<(const ServiceDescriptor&, const ServiceDescriptor&);

class CppIceBoxDescriptor;
ICE_PACK_API bool operator==(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);
ICE_PACK_API bool operator!=(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);
ICE_PACK_API bool operator<(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);

class JavaIceBoxDescriptor;
ICE_PACK_API bool operator==(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);
ICE_PACK_API bool operator!=(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);
ICE_PACK_API bool operator<(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);

class ApplicationDescriptor;
ICE_PACK_API bool operator==(const ApplicationDescriptor&, const ApplicationDescriptor&);
ICE_PACK_API bool operator!=(const ApplicationDescriptor&, const ApplicationDescriptor&);
ICE_PACK_API bool operator<(const ApplicationDescriptor&, const ApplicationDescriptor&);

class Admin;
ICE_PACK_API bool operator==(const Admin&, const Admin&);
ICE_PACK_API bool operator!=(const Admin&, const Admin&);
ICE_PACK_API bool operator<(const Admin&, const Admin&);

}

}

namespace IcePack
{

class ComponentDescriptor;
ICE_PACK_API bool operator==(const ComponentDescriptor&, const ComponentDescriptor&);
ICE_PACK_API bool operator!=(const ComponentDescriptor&, const ComponentDescriptor&);
ICE_PACK_API bool operator<(const ComponentDescriptor&, const ComponentDescriptor&);

class ServerDescriptor;
ICE_PACK_API bool operator==(const ServerDescriptor&, const ServerDescriptor&);
ICE_PACK_API bool operator!=(const ServerDescriptor&, const ServerDescriptor&);
ICE_PACK_API bool operator<(const ServerDescriptor&, const ServerDescriptor&);

class JavaServerDescriptor;
ICE_PACK_API bool operator==(const JavaServerDescriptor&, const JavaServerDescriptor&);
ICE_PACK_API bool operator!=(const JavaServerDescriptor&, const JavaServerDescriptor&);
ICE_PACK_API bool operator<(const JavaServerDescriptor&, const JavaServerDescriptor&);

class ServiceDescriptor;
ICE_PACK_API bool operator==(const ServiceDescriptor&, const ServiceDescriptor&);
ICE_PACK_API bool operator!=(const ServiceDescriptor&, const ServiceDescriptor&);
ICE_PACK_API bool operator<(const ServiceDescriptor&, const ServiceDescriptor&);

class CppIceBoxDescriptor;
ICE_PACK_API bool operator==(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);
ICE_PACK_API bool operator!=(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);
ICE_PACK_API bool operator<(const CppIceBoxDescriptor&, const CppIceBoxDescriptor&);

class JavaIceBoxDescriptor;
ICE_PACK_API bool operator==(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);
ICE_PACK_API bool operator!=(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);
ICE_PACK_API bool operator<(const JavaIceBoxDescriptor&, const JavaIceBoxDescriptor&);

class ApplicationDescriptor;
ICE_PACK_API bool operator==(const ApplicationDescriptor&, const ApplicationDescriptor&);
ICE_PACK_API bool operator!=(const ApplicationDescriptor&, const ApplicationDescriptor&);
ICE_PACK_API bool operator<(const ApplicationDescriptor&, const ApplicationDescriptor&);

class Admin;
ICE_PACK_API bool operator==(const Admin&, const Admin&);
ICE_PACK_API bool operator!=(const Admin&, const Admin&);
ICE_PACK_API bool operator<(const Admin&, const Admin&);

}

namespace IceInternal
{

ICE_PACK_API void incRef(::IcePack::ComponentDescriptor*);
ICE_PACK_API void decRef(::IcePack::ComponentDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::ComponentDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::ComponentDescriptor*);

ICE_PACK_API void incRef(::IcePack::ServerDescriptor*);
ICE_PACK_API void decRef(::IcePack::ServerDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::ServerDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::ServerDescriptor*);

ICE_PACK_API void incRef(::IcePack::JavaServerDescriptor*);
ICE_PACK_API void decRef(::IcePack::JavaServerDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::JavaServerDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::JavaServerDescriptor*);

ICE_PACK_API void incRef(::IcePack::ServiceDescriptor*);
ICE_PACK_API void decRef(::IcePack::ServiceDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::ServiceDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::ServiceDescriptor*);

ICE_PACK_API void incRef(::IcePack::CppIceBoxDescriptor*);
ICE_PACK_API void decRef(::IcePack::CppIceBoxDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::CppIceBoxDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::CppIceBoxDescriptor*);

ICE_PACK_API void incRef(::IcePack::JavaIceBoxDescriptor*);
ICE_PACK_API void decRef(::IcePack::JavaIceBoxDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::JavaIceBoxDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::JavaIceBoxDescriptor*);

ICE_PACK_API void incRef(::IcePack::ApplicationDescriptor*);
ICE_PACK_API void decRef(::IcePack::ApplicationDescriptor*);

ICE_PACK_API void incRef(::IceProxy::IcePack::ApplicationDescriptor*);
ICE_PACK_API void decRef(::IceProxy::IcePack::ApplicationDescriptor*);

ICE_PACK_API void incRef(::IcePack::Admin*);
ICE_PACK_API void decRef(::IcePack::Admin*);

ICE_PACK_API void incRef(::IceProxy::IcePack::Admin*);
ICE_PACK_API void decRef(::IceProxy::IcePack::Admin*);

}

namespace IcePack
{

typedef ::IceInternal::Handle< ::IcePack::ComponentDescriptor> ComponentDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::ComponentDescriptor> ComponentDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const ComponentDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ComponentDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ComponentDescriptorPtr&);
ICE_PACK_API void __patch__ComponentDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::ServerDescriptor> ServerDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::ServerDescriptor> ServerDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServerDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServerDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServerDescriptorPtr&);
ICE_PACK_API void __patch__ServerDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::JavaServerDescriptor> JavaServerDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::JavaServerDescriptor> JavaServerDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const JavaServerDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, JavaServerDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const JavaServerDescriptorPtr&);
ICE_PACK_API void __patch__JavaServerDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::ServiceDescriptor> ServiceDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::ServiceDescriptor> ServiceDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServiceDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServiceDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServiceDescriptorPtr&);
ICE_PACK_API void __patch__ServiceDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::CppIceBoxDescriptor> CppIceBoxDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::CppIceBoxDescriptor> CppIceBoxDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const CppIceBoxDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, CppIceBoxDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const CppIceBoxDescriptorPtr&);
ICE_PACK_API void __patch__CppIceBoxDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::JavaIceBoxDescriptor> JavaIceBoxDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::JavaIceBoxDescriptor> JavaIceBoxDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const JavaIceBoxDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, JavaIceBoxDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const JavaIceBoxDescriptorPtr&);
ICE_PACK_API void __patch__JavaIceBoxDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::ApplicationDescriptor> ApplicationDescriptorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::ApplicationDescriptor> ApplicationDescriptorPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const ApplicationDescriptorPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ApplicationDescriptorPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ApplicationDescriptorPtr&);
ICE_PACK_API void __patch__ApplicationDescriptorPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePack::Admin> AdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::Admin> AdminPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const AdminPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, AdminPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const AdminPtr&);
ICE_PACK_API void __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

namespace IcePack
{

enum ServerActivation
{
    OnDemand,
    Manual
};

ICE_PACK_API void __write(::IceInternal::BasicStream*, ServerActivation);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServerActivation&);

struct ObjectDescriptor
{
    ::Ice::ObjectPrx proxy;

    ::std::string type;

    ::std::string adapterId;

    ICE_PACK_API bool operator==(const ObjectDescriptor&) const;
    ICE_PACK_API bool operator!=(const ObjectDescriptor&) const;
    ICE_PACK_API bool operator<(const ObjectDescriptor&) const;

    ICE_PACK_API void __write(::IceInternal::BasicStream*) const;
    ICE_PACK_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IcePack::ObjectDescriptor> ObjectDescriptorSeq;

class __U__ObjectDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ObjectDescriptorSeq&, __U__ObjectDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ObjectDescriptorSeq&, __U__ObjectDescriptorSeq);

struct AdapterDescriptor
{
    ::std::string name;

    ::std::string id;

    ::std::string endpoints;

    bool registerProcess;

    ::IcePack::ObjectDescriptorSeq objects;

    ICE_PACK_API bool operator==(const AdapterDescriptor&) const;
    ICE_PACK_API bool operator!=(const AdapterDescriptor&) const;
    ICE_PACK_API bool operator<(const AdapterDescriptor&) const;

    ICE_PACK_API void __write(::IceInternal::BasicStream*) const;
    ICE_PACK_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IcePack::AdapterDescriptor> AdapterDescriptorSeq;

class __U__AdapterDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const AdapterDescriptorSeq&, __U__AdapterDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, AdapterDescriptorSeq&, __U__AdapterDescriptorSeq);

struct PropertyDescriptor
{
    ::std::string name;

    ::std::string value;

    ICE_PACK_API bool operator==(const PropertyDescriptor&) const;
    ICE_PACK_API bool operator!=(const PropertyDescriptor&) const;
    ICE_PACK_API bool operator<(const PropertyDescriptor&) const;

    ICE_PACK_API void __write(::IceInternal::BasicStream*) const;
    ICE_PACK_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IcePack::PropertyDescriptor> PropertyDescriptorSeq;

class __U__PropertyDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const PropertyDescriptorSeq&, __U__PropertyDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, PropertyDescriptorSeq&, __U__PropertyDescriptorSeq);

struct DbEnvDescriptor
{
    ::std::string name;

    ::std::string dbHome;

    ::IcePack::PropertyDescriptorSeq properties;

    ICE_PACK_API bool operator==(const DbEnvDescriptor&) const;
    ICE_PACK_API bool operator!=(const DbEnvDescriptor&) const;
    ICE_PACK_API bool operator<(const DbEnvDescriptor&) const;

    ICE_PACK_API void __write(::IceInternal::BasicStream*) const;
    ICE_PACK_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IcePack::DbEnvDescriptor> DbEnvDescriptorSeq;

class __U__DbEnvDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const DbEnvDescriptorSeq&, __U__DbEnvDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, DbEnvDescriptorSeq&, __U__DbEnvDescriptorSeq);

typedef ::std::vector< ::IcePack::ServerDescriptorPtr> ServerDescriptorSeq;

class __U__ServerDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServerDescriptorSeq&, __U__ServerDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServerDescriptorSeq&, __U__ServerDescriptorSeq);

typedef ::std::vector< ::IcePack::ServiceDescriptorPtr> ServiceDescriptorSeq;

class __U__ServiceDescriptorSeq { };
ICE_PACK_API void __write(::IceInternal::BasicStream*, const ServiceDescriptorSeq&, __U__ServiceDescriptorSeq);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServiceDescriptorSeq&, __U__ServiceDescriptorSeq);

enum ServerState
{
    Inactive,
    Activating,
    Active,
    Deactivating,
    Destroying,
    Destroyed
};

ICE_PACK_API void __write(::IceInternal::BasicStream*, ServerState);
ICE_PACK_API void __read(::IceInternal::BasicStream*, ServerState&);

}

namespace IceProxy
{

namespace IcePack
{

class ICE_PACK_API ComponentDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API ServerDescriptor : virtual public ::IceProxy::IcePack::ComponentDescriptor
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API JavaServerDescriptor : virtual public ::IceProxy::IcePack::ServerDescriptor
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API ServiceDescriptor : virtual public ::IceProxy::IcePack::ComponentDescriptor
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API CppIceBoxDescriptor : virtual public ::IceProxy::IcePack::ServerDescriptor
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API JavaIceBoxDescriptor : virtual public ::IceProxy::IcePack::JavaServerDescriptor
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API ApplicationDescriptor : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PACK_API Admin : virtual public ::IceProxy::Ice::Object
{
public:

    void addApplication(const ::IcePack::ApplicationDescriptorPtr&);
    void addApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    void updateApplication(const ::IcePack::ApplicationDescriptorPtr&);
    void updateApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    ::Ice::StringSeq getAllApplicationNames();
    ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    void removeApplication(const ::std::string&);
    void removeApplication(const ::std::string&, const ::Ice::Context&);

    ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&);
    ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    void addServer(const ::IcePack::ServerDescriptorPtr&);
    void addServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    void updateServer(const ::IcePack::ServerDescriptorPtr&);
    void updateServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    void removeServer(const ::std::string&);
    void removeServer(const ::std::string&, const ::Ice::Context&);

    ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&);
    ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&, const ::Ice::Context&);

    ::IcePack::ServerState getServerState(const ::std::string&);
    ::IcePack::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    ::Ice::Int getServerPid(const ::std::string&);
    ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    ::IcePack::ServerActivation getServerActivation(const ::std::string&);
    ::IcePack::ServerActivation getServerActivation(const ::std::string&, const ::Ice::Context&);

    void setServerActivation(const ::std::string&, ::IcePack::ServerActivation);
    void setServerActivation(const ::std::string&, ::IcePack::ServerActivation, const ::Ice::Context&);

    bool startServer(const ::std::string&);
    bool startServer(const ::std::string&, const ::Ice::Context&);

    void stopServer(const ::std::string&);
    void stopServer(const ::std::string&, const ::Ice::Context&);

    void sendSignal(const ::std::string&, const ::std::string&);
    void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int);
    void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    ::Ice::StringSeq getAllServerNames();
    ::Ice::StringSeq getAllServerNames(const ::Ice::Context&);

    ::std::string getAdapterEndpoints(const ::std::string&);
    ::std::string getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    ::Ice::StringSeq getAllAdapterIds();
    ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    void addObject(const ::Ice::ObjectPrx&);
    void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&);
    void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    void removeObject(const ::Ice::Identity&);
    void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&);
    ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&, const ::Ice::Context&);

    ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&);
    ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&, const ::Ice::Context&);

    bool pingNode(const ::std::string&);
    bool pingNode(const ::std::string&, const ::Ice::Context&);

    void shutdownNode(const ::std::string&);
    void shutdownNode(const ::std::string&, const ::Ice::Context&);

    void removeNode(const ::std::string&);
    void removeNode(const ::std::string&, const ::Ice::Context&);

    ::std::string getNodeHostname(const ::std::string&);
    ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    ::Ice::StringSeq getAllNodeNames();
    ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    void shutdown();
    void shutdown(const ::Ice::Context&);

    ::Ice::SliceChecksumDict getSliceChecksums();
    ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IcePack
{

class ICE_PACK_API ComponentDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class ICE_PACK_API ServerDescriptor : virtual public ::IceDelegate::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API JavaServerDescriptor : virtual public ::IceDelegate::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API ServiceDescriptor : virtual public ::IceDelegate::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API CppIceBoxDescriptor : virtual public ::IceDelegate::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API JavaIceBoxDescriptor : virtual public ::IceDelegate::IcePack::JavaServerDescriptor
{
public:
};

class ICE_PACK_API ApplicationDescriptor : virtual public ::IceDelegate::Ice::Object
{
public:
};

class ICE_PACK_API Admin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void addApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&) = 0;

    virtual void updateApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&) = 0;

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void addServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&) = 0;

    virtual void updateServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&) = 0;

    virtual void removeServer(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ServerState getServerState(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ServerActivation getServerActivation(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void setServerActivation(const ::std::string&, ::IcePack::ServerActivation, const ::Ice::Context&) = 0;

    virtual bool startServer(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void stopServer(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllServerNames(const ::Ice::Context&) = 0;

    virtual ::std::string getAdapterEndpoints(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&) = 0;

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&) = 0;

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&, const ::Ice::Context&) = 0;

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void removeNode(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&) = 0;

    virtual void shutdown(const ::Ice::Context&) = 0;

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IcePack
{

class ICE_PACK_API ComponentDescriptor : virtual public ::IceDelegate::IcePack::ComponentDescriptor,
					 virtual public ::IceDelegateM::Ice::Object
{
public:
};

class ICE_PACK_API ServerDescriptor : virtual public ::IceDelegate::IcePack::ServerDescriptor,
				      virtual public ::IceDelegateM::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API JavaServerDescriptor : virtual public ::IceDelegate::IcePack::JavaServerDescriptor,
					  virtual public ::IceDelegateM::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API ServiceDescriptor : virtual public ::IceDelegate::IcePack::ServiceDescriptor,
				       virtual public ::IceDelegateM::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API CppIceBoxDescriptor : virtual public ::IceDelegate::IcePack::CppIceBoxDescriptor,
					 virtual public ::IceDelegateM::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API JavaIceBoxDescriptor : virtual public ::IceDelegate::IcePack::JavaIceBoxDescriptor,
					  virtual public ::IceDelegateM::IcePack::JavaServerDescriptor
{
public:
};

class ICE_PACK_API ApplicationDescriptor : virtual public ::IceDelegate::IcePack::ApplicationDescriptor,
					   virtual public ::IceDelegateM::Ice::Object
{
public:
};

class ICE_PACK_API Admin : virtual public ::IceDelegate::IcePack::Admin,
			   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void addApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    virtual void updateApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual void addServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    virtual void updateServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    virtual void removeServer(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerActivation getServerActivation(const ::std::string&, const ::Ice::Context&);

    virtual void setServerActivation(const ::std::string&, ::IcePack::ServerActivation, const ::Ice::Context&);

    virtual bool startServer(const ::std::string&, const ::Ice::Context&);

    virtual void stopServer(const ::std::string&, const ::Ice::Context&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllServerNames(const ::Ice::Context&);

    virtual ::std::string getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&, const ::Ice::Context&);

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&);

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&);

    virtual void removeNode(const ::std::string&, const ::Ice::Context&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    virtual void shutdown(const ::Ice::Context&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IcePack
{

class ICE_PACK_API ComponentDescriptor : virtual public ::IceDelegate::IcePack::ComponentDescriptor,
					 virtual public ::IceDelegateD::Ice::Object
{
public:
};

class ICE_PACK_API ServerDescriptor : virtual public ::IceDelegate::IcePack::ServerDescriptor,
				      virtual public ::IceDelegateD::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API JavaServerDescriptor : virtual public ::IceDelegate::IcePack::JavaServerDescriptor,
					  virtual public ::IceDelegateD::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API ServiceDescriptor : virtual public ::IceDelegate::IcePack::ServiceDescriptor,
				       virtual public ::IceDelegateD::IcePack::ComponentDescriptor
{
public:
};

class ICE_PACK_API CppIceBoxDescriptor : virtual public ::IceDelegate::IcePack::CppIceBoxDescriptor,
					 virtual public ::IceDelegateD::IcePack::ServerDescriptor
{
public:
};

class ICE_PACK_API JavaIceBoxDescriptor : virtual public ::IceDelegate::IcePack::JavaIceBoxDescriptor,
					  virtual public ::IceDelegateD::IcePack::JavaServerDescriptor
{
public:
};

class ICE_PACK_API ApplicationDescriptor : virtual public ::IceDelegate::IcePack::ApplicationDescriptor,
					   virtual public ::IceDelegateD::Ice::Object
{
public:
};

class ICE_PACK_API Admin : virtual public ::IceDelegate::IcePack::Admin,
			   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void addApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    virtual void updateApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual void addServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    virtual void updateServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Context&);

    virtual void removeServer(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    virtual ::IcePack::ServerActivation getServerActivation(const ::std::string&, const ::Ice::Context&);

    virtual void setServerActivation(const ::std::string&, ::IcePack::ServerActivation, const ::Ice::Context&);

    virtual bool startServer(const ::std::string&, const ::Ice::Context&);

    virtual void stopServer(const ::std::string&, const ::Ice::Context&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllServerNames(const ::Ice::Context&);

    virtual ::std::string getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&, const ::Ice::Context&);

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&);

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&);

    virtual void removeNode(const ::std::string&, const ::Ice::Context&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    virtual void shutdown(const ::Ice::Context&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
};

}

}

namespace IcePack
{

class ICE_PACK_API ComponentDescriptor : virtual public ::Ice::Object
{
public:

    void __copyMembers(::IcePack::ComponentDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string name;

    ::IcePack::AdapterDescriptorSeq adapters;

    ::IcePack::PropertyDescriptorSeq properties;

    ::IcePack::DbEnvDescriptorSeq dbEnvs;

    ::std::string comment;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::ComponentDescriptor __ComponentDescriptor_init;

void ICE_PACK_API __patch__ComponentDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API ServerDescriptor : virtual public ::IcePack::ComponentDescriptor
{
public:

    void __copyMembers(::IcePack::ServerDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string exe;

    ::std::string pwd;

    ::std::string node;

    ::std::string application;

    ::Ice::StringSeq options;

    ::Ice::StringSeq envs;

    ::IcePack::ServerActivation activation;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::ServerDescriptor __ServerDescriptor_init;

void ICE_PACK_API __patch__ServerDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API JavaServerDescriptor : virtual public ::IcePack::ServerDescriptor
{
public:

    void __copyMembers(::IcePack::JavaServerDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string className;

    ::Ice::StringSeq jvmOptions;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::JavaServerDescriptor __JavaServerDescriptor_init;

void ICE_PACK_API __patch__JavaServerDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API ServiceDescriptor : virtual public ::IcePack::ComponentDescriptor
{
public:

    void __copyMembers(::IcePack::ServiceDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string entry;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::ServiceDescriptor __ServiceDescriptor_init;

void ICE_PACK_API __patch__ServiceDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API CppIceBoxDescriptor : virtual public ::IcePack::ServerDescriptor
{
public:

    void __copyMembers(::IcePack::CppIceBoxDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();
    virtual void __incRef();
    virtual void __decRef();
    virtual void __gcReachable(::IceUtil::GCObjectMultiSet&) const;
    virtual void __gcClear();

    ::IcePack::ServiceDescriptorSeq services;

    ::std::string endpoints;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::CppIceBoxDescriptor __CppIceBoxDescriptor_init;

void ICE_PACK_API __patch__CppIceBoxDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API JavaIceBoxDescriptor : virtual public ::IcePack::JavaServerDescriptor
{
public:

    void __copyMembers(::IcePack::JavaIceBoxDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();
    virtual void __incRef();
    virtual void __decRef();
    virtual void __gcReachable(::IceUtil::GCObjectMultiSet&) const;
    virtual void __gcClear();

    ::IcePack::ServiceDescriptorSeq services;

    ::std::string endpoints;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::JavaIceBoxDescriptor __JavaIceBoxDescriptor_init;

void ICE_PACK_API __patch__JavaIceBoxDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API ApplicationDescriptor : virtual public ::Ice::Object
{
public:

    void __copyMembers(::IcePack::ApplicationDescriptorPtr) const;
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();
    virtual void __incRef();
    virtual void __decRef();
    virtual void __gcReachable(::IceUtil::GCObjectMultiSet&) const;
    virtual void __gcClear();

    ::std::string name;

    ::IcePack::ServerDescriptorSeq servers;

    ::std::string comment;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::IcePack::ApplicationDescriptor __ApplicationDescriptor_init;

void ICE_PACK_API __patch__ApplicationDescriptorPtr(void*, ::Ice::ObjectPtr&);

class ICE_PACK_API Admin : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void addApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateApplication(const ::IcePack::ApplicationDescriptorPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllApplicationNames(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void removeApplication(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IcePack::ApplicationDescriptorPtr getApplicationDescriptor(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getApplicationDescriptor(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void addServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateServer(const ::IcePack::ServerDescriptorPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeServer(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IcePack::ServerDescriptorPtr getServerDescriptor(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerDescriptor(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IcePack::ServerState getServerState(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerState(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerPid(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IcePack::ServerActivation getServerActivation(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerActivation(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void setServerActivation(const ::std::string&, ::IcePack::ServerActivation, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___setServerActivation(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool startServer(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___startServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void stopServer(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___stopServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___sendSignal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___writeMessage(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::StringSeq getAllServerNames(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllServerNames(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::std::string getAdapterEndpoints(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAdapterEndpoints(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllAdapterIds(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addObjectWithType(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IcePack::ObjectDescriptor getObjectDescriptor(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getObjectDescriptor(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IcePack::ObjectDescriptorSeq getAllObjectDescriptors(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllObjectDescriptors(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual bool pingNode(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___pingNode(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdownNode(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdownNode(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeNode(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeNode(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getNodeHostname(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllNodeNames(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getSliceChecksums(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_PACK_API __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

#endif
