// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Query.ice'

#ifndef __IcePack_Query_h__
#define __IcePack_Query_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <IcePack/Exception.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_PACK_API
#   ifdef ICE_PACK_API_EXPORTS
#       define ICE_PACK_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_PACK_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IcePack
{

class Query;
ICE_PACK_API bool operator==(const Query&, const Query&);
ICE_PACK_API bool operator!=(const Query&, const Query&);
ICE_PACK_API bool operator<(const Query&, const Query&);

}

}

namespace IcePack
{

class Query;
ICE_PACK_API bool operator==(const Query&, const Query&);
ICE_PACK_API bool operator!=(const Query&, const Query&);
ICE_PACK_API bool operator<(const Query&, const Query&);

}

namespace IceInternal
{

ICE_PACK_API void incRef(::IcePack::Query*);
ICE_PACK_API void decRef(::IcePack::Query*);

ICE_PACK_API void incRef(::IceProxy::IcePack::Query*);
ICE_PACK_API void decRef(::IceProxy::IcePack::Query*);

}

namespace IcePack
{

typedef ::IceInternal::Handle< ::IcePack::Query> QueryPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePack::Query> QueryPrx;

ICE_PACK_API void __write(::IceInternal::BasicStream*, const QueryPrx&);
ICE_PACK_API void __read(::IceInternal::BasicStream*, QueryPrx&);
ICE_PACK_API void __write(::IceInternal::BasicStream*, const QueryPtr&);
ICE_PACK_API void __patch__QueryPtr(void*, ::Ice::ObjectPtr&);

}

namespace IcePack
{

}

namespace IceProxy
{

namespace IcePack
{

class ICE_PACK_API Query : virtual public ::IceProxy::Ice::Object
{
public:

    ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&);
    ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&, const ::Ice::Context&);

    ::Ice::ObjectPrx findObjectByType(const ::std::string&);
    ::Ice::ObjectPrx findObjectByType(const ::std::string&, const ::Ice::Context&);

    ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&);
    ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IcePack
{

class ICE_PACK_API Query : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::Ice::ObjectPrx findObjectByType(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IcePack
{

class ICE_PACK_API Query : virtual public ::IceDelegate::IcePack::Query,
			   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::Ice::ObjectPrx findObjectByType(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IcePack
{

class ICE_PACK_API Query : virtual public ::IceDelegate::IcePack::Query,
			   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::Ice::ObjectPrx findObjectByType(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IcePack
{

class ICE_PACK_API Query : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Ice::ObjectPrx findObjectById(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___findObjectById(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ObjectPrx findObjectByType(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___findObjectByType(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ObjectProxySeq findAllObjectsWithType(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___findAllObjectsWithType(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_PACK_API __patch__QueryPtr(void*, ::Ice::ObjectPtr&);

}

#endif
