// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `FileInfo.ice'

#ifndef __IcePatch2_FileInfo_h__
#define __IcePatch2_FileInfo_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/BuiltinSequences.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_PATCH2_API
#   ifdef ICE_PATCH2_API_EXPORTS
#       define ICE_PATCH2_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_PATCH2_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IcePatch2
{

struct FileInfo
{
    ::std::string path;

    ::Ice::ByteSeq checksum;

    ::Ice::Int size;

    ICE_PATCH2_API bool operator==(const FileInfo&) const;
    ICE_PATCH2_API bool operator!=(const FileInfo&) const;
    ICE_PATCH2_API bool operator<(const FileInfo&) const;

    ICE_PATCH2_API void __write(::IceInternal::BasicStream*) const;
    ICE_PATCH2_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IcePatch2::FileInfo> FileInfoSeq;

class __U__FileInfoSeq { };
ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const FileInfoSeq&, __U__FileInfoSeq);
ICE_PATCH2_API void __read(::IceInternal::BasicStream*, FileInfoSeq&, __U__FileInfoSeq);

}

#endif
