// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `FileServer.ice'

#ifndef __IcePatch2_FileServer_h__
#define __IcePatch2_FileServer_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IcePatch2/FileInfo.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_PATCH2_API
#   ifdef ICE_PATCH2_API_EXPORTS
#       define ICE_PATCH2_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_PATCH2_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IcePatch2
{

class FileServer;
ICE_PATCH2_API bool operator==(const FileServer&, const FileServer&);
ICE_PATCH2_API bool operator!=(const FileServer&, const FileServer&);
ICE_PATCH2_API bool operator<(const FileServer&, const FileServer&);

class Admin;
ICE_PATCH2_API bool operator==(const Admin&, const Admin&);
ICE_PATCH2_API bool operator!=(const Admin&, const Admin&);
ICE_PATCH2_API bool operator<(const Admin&, const Admin&);

}

}

namespace IcePatch2
{

class FileServer;
ICE_PATCH2_API bool operator==(const FileServer&, const FileServer&);
ICE_PATCH2_API bool operator!=(const FileServer&, const FileServer&);
ICE_PATCH2_API bool operator<(const FileServer&, const FileServer&);

class Admin;
ICE_PATCH2_API bool operator==(const Admin&, const Admin&);
ICE_PATCH2_API bool operator!=(const Admin&, const Admin&);
ICE_PATCH2_API bool operator<(const Admin&, const Admin&);

}

namespace IceInternal
{

ICE_PATCH2_API void incRef(::IcePatch2::FileServer*);
ICE_PATCH2_API void decRef(::IcePatch2::FileServer*);

ICE_PATCH2_API void incRef(::IceProxy::IcePatch2::FileServer*);
ICE_PATCH2_API void decRef(::IceProxy::IcePatch2::FileServer*);

ICE_PATCH2_API void incRef(::IcePatch2::Admin*);
ICE_PATCH2_API void decRef(::IcePatch2::Admin*);

ICE_PATCH2_API void incRef(::IceProxy::IcePatch2::Admin*);
ICE_PATCH2_API void decRef(::IceProxy::IcePatch2::Admin*);

}

namespace IcePatch2
{

typedef ::IceInternal::Handle< ::IcePatch2::FileServer> FileServerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePatch2::FileServer> FileServerPrx;

ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const FileServerPrx&);
ICE_PATCH2_API void __read(::IceInternal::BasicStream*, FileServerPrx&);
ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const FileServerPtr&);
ICE_PATCH2_API void __patch__FileServerPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IcePatch2::Admin> AdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IcePatch2::Admin> AdminPrx;

ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const AdminPrx&);
ICE_PATCH2_API void __read(::IceInternal::BasicStream*, AdminPrx&);
ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const AdminPtr&);
ICE_PATCH2_API void __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

namespace IcePatch2
{

typedef ::std::vector< ::Ice::ByteSeq> ByteSeqSeq;

class __U__ByteSeqSeq { };
ICE_PATCH2_API void __write(::IceInternal::BasicStream*, const ByteSeqSeq&, __U__ByteSeqSeq);
ICE_PATCH2_API void __read(::IceInternal::BasicStream*, ByteSeqSeq&, __U__ByteSeqSeq);

class ICE_PATCH2_API PartitionOutOfRangeException : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static PartitionOutOfRangeException __PartitionOutOfRangeException_init;

class ICE_PATCH2_API FileAccessException : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static FileAccessException __FileAccessException_init;

}

namespace IcePatch2
{

class ICE_PATCH2_API AMI_FileServer_getFileInfoSeq : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::IcePatch2::FileInfoSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IcePatch2::FileServerPrx&, ::Ice::Int, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IcePatch2::AMI_FileServer_getFileInfoSeq> AMI_FileServer_getFileInfoSeqPtr;

class ICE_PATCH2_API AMI_FileServer_getFileCompressed : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::Ice::ByteSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IcePatch2::FileServerPrx&, const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IcePatch2::AMI_FileServer_getFileCompressed> AMI_FileServer_getFileCompressedPtr;

}

namespace IceProxy
{

namespace IcePatch2
{

class ICE_PATCH2_API FileServer : virtual public ::IceProxy::Ice::Object
{
public:

    ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int);
    ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int, const ::Ice::Context&);
    void getFileInfoSeq_async(const::IcePatch2::AMI_FileServer_getFileInfoSeqPtr&, ::Ice::Int);
    void getFileInfoSeq_async(const::IcePatch2::AMI_FileServer_getFileInfoSeqPtr&, ::Ice::Int, const ::Ice::Context&);

    ::IcePatch2::ByteSeqSeq getChecksumSeq();
    ::IcePatch2::ByteSeqSeq getChecksumSeq(const ::Ice::Context&);

    ::Ice::ByteSeq getChecksum();
    ::Ice::ByteSeq getChecksum(const ::Ice::Context&);

    ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int);
    ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&);
    void getFileCompressed_async(const::IcePatch2::AMI_FileServer_getFileCompressedPtr&, const ::std::string&, ::Ice::Int, ::Ice::Int);
    void getFileCompressed_async(const::IcePatch2::AMI_FileServer_getFileCompressedPtr&, const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_PATCH2_API Admin : virtual public ::IceProxy::Ice::Object
{
public:

    void shutdown();
    void shutdown(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IcePatch2
{

class ICE_PATCH2_API FileServer : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int, const ::Ice::Context&) = 0;

    virtual ::IcePatch2::ByteSeqSeq getChecksumSeq(const ::Ice::Context&) = 0;

    virtual ::Ice::ByteSeq getChecksum(const ::Ice::Context&) = 0;

    virtual ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&) = 0;
};

class ICE_PATCH2_API Admin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IcePatch2
{

class ICE_PATCH2_API FileServer : virtual public ::IceDelegate::IcePatch2::FileServer,
				  virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int, const ::Ice::Context&);

    virtual ::IcePatch2::ByteSeqSeq getChecksumSeq(const ::Ice::Context&);

    virtual ::Ice::ByteSeq getChecksum(const ::Ice::Context&);

    virtual ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&);
};

class ICE_PATCH2_API Admin : virtual public ::IceDelegate::IcePatch2::Admin,
			     virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IcePatch2
{

class ICE_PATCH2_API FileServer : virtual public ::IceDelegate::IcePatch2::FileServer,
				  virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int, const ::Ice::Context&);

    virtual ::IcePatch2::ByteSeqSeq getChecksumSeq(const ::Ice::Context&);

    virtual ::Ice::ByteSeq getChecksum(const ::Ice::Context&);

    virtual ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context&);
};

class ICE_PATCH2_API Admin : virtual public ::IceDelegate::IcePatch2::Admin,
			     virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void shutdown(const ::Ice::Context&);
};

}

}

namespace IcePatch2
{

class ICE_PATCH2_API FileServer : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IcePatch2::FileInfoSeq getFileInfoSeq(::Ice::Int, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getFileInfoSeq(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IcePatch2::ByteSeqSeq getChecksumSeq(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getChecksumSeq(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ByteSeq getChecksum(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getChecksum(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::ByteSeq getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getFileCompressed(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_PATCH2_API __patch__FileServerPtr(void*, ::Ice::ObjectPtr&);

class ICE_PATCH2_API Admin : virtual public ::Ice::Object
{
public:

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_PATCH2_API __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

#endif
