// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Plugin.ice'

#ifndef __IceSSL_Plugin_h__
#define __IceSSL_Plugin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/Plugin.h>
#include <IceSSL/CertificateVerifierF.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 20102
#       error Ice version mismatch!
#   endif
#endif

#ifndef ICE_SSL_API
#   ifdef ICE_SSL_API_EXPORTS
#       define ICE_SSL_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_SSL_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceSSL
{

class Plugin;
ICE_SSL_API bool operator==(const Plugin&, const Plugin&);
ICE_SSL_API bool operator!=(const Plugin&, const Plugin&);
ICE_SSL_API bool operator<(const Plugin&, const Plugin&);

}

namespace IceInternal
{

ICE_SSL_API void incRef(::IceSSL::Plugin*);
ICE_SSL_API void decRef(::IceSSL::Plugin*);

}

namespace IceSSL
{

typedef ::IceInternal::Handle< ::IceSSL::Plugin> PluginPtr;

}

namespace IceSSL
{

enum ContextType
{
    Client,
    Server,
    ClientServer
};

ICE_SSL_API void __write(::IceInternal::BasicStream*, ContextType);
ICE_SSL_API void __read(::IceInternal::BasicStream*, ContextType&);

}

namespace IceSSL
{

class ICE_SSL_API Plugin : virtual public ::Ice::Plugin
{
public:

    virtual void configure(::IceSSL::ContextType) = 0;

    virtual void loadConfig(::IceSSL::ContextType, const ::std::string&, const ::std::string&) = 0;

    virtual void setCertificateVerifier(::IceSSL::ContextType, const ::IceSSL::CertificateVerifierPtr&) = 0;

    virtual void addTrustedCertificateBase64(::IceSSL::ContextType, const ::std::string&) = 0;

    virtual void addTrustedCertificate(::IceSSL::ContextType, const ::Ice::ByteSeq&) = 0;

    virtual void setRSAKeysBase64(::IceSSL::ContextType, const ::std::string&, const ::std::string&) = 0;

    virtual void setRSAKeys(::IceSSL::ContextType, const ::Ice::ByteSeq&, const ::Ice::ByteSeq&) = 0;

    virtual ::IceSSL::CertificateVerifierPtr getDefaultCertVerifier() = 0;

    virtual ::IceSSL::CertificateVerifierPtr getSingleCertVerifier(const ::Ice::ByteSeq&) = 0;
};

}

#endif
